/**
 * @file       platform_includes.h
 * @author     Pere Tuset-Peiro (peretuset@openmote.com)
 * @version    v0.1
 * @date       November, 2018
 * @brief
 *
 * @copyright  Copyright 2018, OpenMote Technologies, S.L.
 *             This file is licensed under the GNU General Public License v2.
 */

#ifndef PLATFROM_INCLUDES_H_
#define PLATFROM_INCLUDES_H_

/*================================ include ==================================*/

#include "ti/cc2538/src/adc.h"
#include "ti/cc2538/src/aes.h"
#include "ti/cc2538/src/ccm.h"
#include "ti/cc2538/src/cpu.h"
#include "ti/cc2538/src/debug.h"
#include "ti/cc2538/src/flash.h"
#include "ti/cc2538/src/gpio.h"
#include "ti/cc2538/src/gptimer.h"
#include "ti/cc2538/src/i2c.h"
#include "ti/cc2538/src/interrupt.h"
#include "ti/cc2538/src/ioc.h"
#include "ti/cc2538/src/pka.h"
#include "ti/cc2538/src/rom.h"
#include "ti/cc2538/src/sha256.h"
#include "ti/cc2538/src/sleepmode.h"
#include "ti/cc2538/src/ssi.h"
#include "ti/cc2538/src/sys_ctrl.h"
#include "ti/cc2538/src/systick.h"
#include "ti/cc2538/src/uart.h"
#include "ti/cc2538/src/udma.h"
#include "ti/cc2538/src/watchdog.h"

#include "ti/cc2538/inc/hw_aes.h"
#include "ti/cc2538/inc/hw_ana_regs.h"
#include "ti/cc2538/inc/hw_cctest.h"
#include "ti/cc2538/inc/hw_flash_ctrl.h"
#include "ti/cc2538/inc/hw_gpio.h"
#include "ti/cc2538/inc/hw_gptimer.h"
#include "ti/cc2538/inc/hw_i2cm.h"
#include "ti/cc2538/inc/hw_i2cs.h"
#include "ti/cc2538/inc/hw_ints.h"
#include "ti/cc2538/inc/hw_ioc.h"
#include "ti/cc2538/inc/hw_memmap.h"
#include "ti/cc2538/inc/hw_nvic.h"
#include "ti/cc2538/inc/hw_pka.h"
#include "ti/cc2538/inc/hw_rfcore_ffsm.h"
#include "ti/cc2538/inc/hw_rfcore_sfr.h"
#include "ti/cc2538/inc/hw_rfcore_xreg.h"
#include "ti/cc2538/inc/hw_smwdthrosc.h"
#include "ti/cc2538/inc/hw_soc_adc.h"
#include "ti/cc2538/inc/hw_ssi.h"
#include "ti/cc2538/inc/hw_sys_ctrl.h"
#include "ti/cc2538/inc/hw_types.h"
#include "ti/cc2538/inc/hw_uart.h"
#include "ti/cc2538/inc/hw_udma.h"
#include "ti/cc2538/inc/hw_udmachctl.h"
#include "ti/cc2538/inc/hw_usb.h"

/*================================ define ===================================*/

/*================================ typedef ==================================*/

/*=============================== variables =================================*/

/*=============================== prototypes ================================*/

/*================================= public ==================================*/

/*================================ private ==================================*/

#endif  /* PLATFROM_INCLUDES_H_ */
